/***************************** Include Files *********************************/
#include <stdio.h>
#include <string.h>
#include <net/xilnet_config.h>
#include <net/xilsock.h>
#include <xgpio_l.h>
#include <xemac_l.h>
#include <xparameters.h>
#include <xuartns550_l.h>
#include "web.h"
#include "http.h"
#include "peripheral.h"
#include <opb_onewire_l.h>

int count = 0;
extern struct web_conn_ent web_conns[MAX_WEB_CONNS];

int main()
{   
	int i;
    int n = 0;
    int s;
    int err;
    struct sockaddr_in addr;
    

	init_uart();


    // Initialize general purpose I/O
    initLedDip();

    // Initialize network device
    init_net();

	// Create the socket
    s = init_socket(&addr);
    if (s == -1) {
        xil_printf("socket() error \n\r");
        exit(1);
    }

    stop_webserver = 0;
    
	for (;;) {

        int alen = 0; 
        
        count = count % 6;        
        
        /* Accept new connections */
        alen = sizeof(struct sockaddr);

        // Accept a new connection. Sets the global xilsock_status_flag.
        err = xilsock_accept(s, (struct sockaddr *)&addr, &alen);
        if (xilsock_status_flag & XILSOCK_NEW_CONN) {
            /* A new connection was found. Add a web connection. */
            add_web_conn(err);
        } 
        /* Process all existing connections */
        if (do_proc_conns()==-1){
            print("WEB server stoped\r\n");
            return 0;
        }
    }

    return 0;
    
}
void init_net() {
    int i;
	unsigned char hw_addr[ETH_ADDR_LEN_PLUS_COLONS];
    Xuint8 ip[16]="192.168.0.3";
       
    print("Starting Up!!\n\r");
    

	OneWire_GetHardwareAddrWithColons(XPAR_ONEWIRE_0_BASEADDR,hw_addr);
	xil_printf("ETH_HW_ADDR: %02x:%02x:%02x:%02x:%02x:%02x \r\n",hw_addr[0],hw_addr[2],hw_addr[4],hw_addr[6],hw_addr[8],hw_addr[10]);

    // Set MAC address (eth.c) of hardware in the TCP/IP stack
    xilnet_eth_init_hw_addr(hw_addr);
    
    // Initialize Ethernet hardware table (eth.c)
    xilnet_eth_init_hw_addr_tbl();
    
    // Set the IP address  (ip.c)
    getIP(ip);
    xilnet_ip_init(ip);

    // Initialize the MAC OPB base address (MAC driver in net/mac.c)
    xilnet_mac_init(XPAR_ETHERNET_MAC_BASEADDR);
    
    // xemac_l.h
    xil_printf("Reseting PHY\n\r");
    XEmac_mPhyReset(XPAR_ETHERNET_MAC_BASEADDR);
    
    // Set the MAC physical Ethernet address in the MAC driver (xemac_l.h)
    XEmac_mSetMacAddress(XPAR_ETHERNET_MAC_BASEADDR, mb_hw_addr);
    
    // Enable MAC (xemac_l.h)
    XEmac_mEnable(XPAR_ETHERNET_MAC_BASEADDR);
    
    // Print IP address
    xil_printf("ip: %d.%d.%d.%d \n\r",
               mb_ip_addr[0], mb_ip_addr[1],mb_ip_addr[2],mb_ip_addr[3]);
    
}
int init_socket(struct sockaddr_in *addr) {
    //struct sockaddr_in addr; // defined in net/in.h
    int s;
    int err;
    
    // Allocate a new socket (xilsock.c)
    s = xilsock_socket(AF_INET, SOCK_STREAM, 0);
    if (s == -1) {
        return -1;
    }
    
    // Define the address for the socket
    addr->sin_family = AF_INET;          //socket.h (IP)
    addr->sin_addr.s_addr = INADDR_ANY;  //net/in.h
    addr->sin_port = SERVER_PORT;        //defined in web.h (web server at 8080)
    
    //Bind the allocated socket to a specific address
    err = xilsock_bind(s, (struct sockaddr *)addr, sizeof(struct sockaddr));
    if (err == -1) {
        xil_printf("bind() error \n\r");
        return(-1);
    }
    
    
    // Enable listening on the socket
    err = xilsock_listen(s, 4);
    if (err == -1) {
        xil_printf("listen() error \n\r");
        return -1;
    }
    
    print("Socket created, bound, and listening. Accepting connections\r\n");
    
    return s;
    
}

void getIP(unsigned char* ipAddr)
{
  int i;
  Xuint8 correct = 'n';
  
  while(correct != 'y'){
    
    xil_printf("Input your IP address(such as 192.168.0.3), hit enter to finish:");
    for(i=0;i<16;i++){
      ipAddr[i] = XUartNs550_RecvByte(UART_BASEADDR);
      xil_printf("%c",ipAddr[i]);
      if(ipAddr[i]=='\r')
        break;
    }
    xil_printf("\n");
    
    xil_printf("Are you sure this IP address is correct?(y/n)");
    correct = XUartNs550_RecvByte(UART_BASEADDR);
    xil_printf("%c\r\n",correct);
  }

  ipAddr[i]='\0';

}
